function dispLocationsHiperb(P,dd,varargin)
%
%dispLocationsHiperb(P,dd)
%
%Megjelenti a lokalizci mrsi eredmnyeit 3 mote esetn.
%Paramterek:
%P: a moteok pozciit tartalmaz cella. Az i-edik cella az i-edik motehoz
%tartozik. Egy-egy cellhoz tartoz vektor az adott mote x-y koordintit
%tartalmazza.
%dd: az egyes moteprok esetn az rkezsi id klnbsgt kell megadni.
%1. motepr: 1-2
%2. motepr: 1-3
%3. motepr: 2-3
%
%Pl.:
%P{1} = [0,0];      %az 1. mote koordinti:  x=0cm    , y=0cm
%P{2} = [40,0.1];   %a  2. mote koordinti:  x=40.01cm, y=0.1cm
%P{3} = [41,50];    %a  3. mote koordinti:  x=41.00cm, y=50cm
%
%dd{1} = 49;       %az 1. mote 49 cm-rel tvolabb van, mint a 2. mote
%dd{2} = 24;       %a  1. mote 24 cm-rel tvolabb van, mint a 3. mote
%dd{3} =-23;       %a  2. mote 23 cm-rel kzelebb van, mint a 3. mote



moteSzam = 3;
moteParSzam = 3;
szin=['b' 'r' 'g' 'm' 'k' 'y'];



leftX  = -150;
rightX =  150;
bottY  = -150;
topY   =  150;

Dscale = 1.2;
frameDisp = [leftX rightX bottY topY]*Dscale;

%moteok kirajzolsa
fig=figure(136);set(fig,'Name','Pozcibecsls hiperbolkkal')
clf
for mote=1:moteSzam
    plot(P{mote}(1),P{mote}(2),'ks','linewidth',3)
    hold on
    texM=text(P{mote}(1)+5*Dscale,P{mote}(2)-5*Dscale,['mote' num2str(mote)]);
end    
hold off
axis(frameDisp)

motePar = 0;
for mote1=1:moteSzam-1
    for mote2 = [(mote1+1):moteSzam]
        motePar = motePar+1;
        aOld = (P{mote2}(2)-P{mote1}(2));
        bOld = (P{mote2}(1)-P{mote1}(1));
        if (bOld==0) bOld = aOld*eps;end%
        beta(motePar) = atan( aOld / bOld );
        beta(motePar) = angle( (aOld*j + bOld) );
        %beta(motePar)*180/pi
        P0{motePar} = (P{mote1}+P{mote2})/2;
    end
end

%mote1=1;mote2=2; beta{1} = atan((P{mote1}(2)-P{mote2}(2))/(P{mote1}(1)-P{mote2}(1)));
%mote1=1;mote2=3; beta{2} = atan((P{mote1}(2)-P{mote2}(2))/(P{mote1}(1)-P{mote2}(1)));
%mote1=2;mote2=3; beta{3} = atan((P{mote1}(2)-P{mote2}(2))/(P{mote1}(1)-P{mote2}(1)));

%moteprok kzppontjnak kiszmtsa
%mote1=1;mote2=2; P0{1} = (P{mote1}+P{mote2})/2;
%mote1=1;mote2=3; P0{2} = (P{mote1}+P{mote2})/2;
%mote1=2;mote2=3; P0{3} = (P{mote1}+P{mote2})/2;


%moteprok kzppontjnak kirajzolsa
for mote=1:moteSzam
hold on
    plot(P0{mote}(1),P0{mote}(2),[szin(mote) 'x'])
end        

hold off
axis(frameDisp)

%d{i}: i-edik motepr tvolsgnak szmtsa
motePar = 0;
for mote1=1:moteSzam-1
    for mote2 = [(mote1+1):moteSzam]
        motePar = motePar+1;
        aOld = (P{mote1}(1)-P{mote2}(1));
        bOld = (P{mote1}(2)-P{mote2}(2));
        d{motePar} = sqrt( aOld^2 + bOld^2 );
        if (abs(dd{motePar})>abs(d{motePar})) %rossz mrs miatt az rkezsi idklnbsg nagyobbnak addik, mint a tvolsg
        		dd{motePar} = sign(dd{motePar}) * abs(d{motePar});   
        end
    end
end

%mote1=1;mote2=2;d{1} = sqrt((P{mote1}(1)-P{mote2}(1))^2+(P{mote1}(2)-P{mote2}(2))^2);
%mote1=1;mote2=3;d{2} = sqrt((P{mote1}(1)-P{mote2}(1))^2+(P{mote1}(2)-P{mote2}(2))^2);
%mote1=2;mote2=3;d{3} = sqrt((P{mote1}(1)-P{mote2}(1))^2+(P{mote1}(2)-P{mote2}(2))^2);


%berkezs szgnek kiszmtsa
for motePar = 1:3
    alfa(motePar) = acos(dd{motePar}/d{motePar});
    if (abs(dd{motePar})>abs(d{motePar})) %ha a mrsben nagyobb rkezsiid-klnbsg addna 
        alfa(motePar) = acos(sign(dd{motePar}/d{motePar}));
    end
end    
    

%lehetsges pozcik szmtsa
for motePar = 1:3
   aSavPos = 0;
   distances = [400:-1:(d{motePar}-dd{motePar})/2 ];
   koord{motePar} = zeros(length(distances)*2,2);
   for a = distances
      b = a + dd{motePar};
		coslamd = 1/(2*a*d{motePar})*(a^2+d{motePar}^2-b^2);
      s = sqrt(a^2+d{motePar}^2/4-a*d{motePar}*coslamd);
      cosfi = 1/(s*d{motePar})*(s^2+d{motePar}^2/4-a^2);
      fi = acos(cosfi);
      aSavPos = aSavPos + 1;
      koord{motePar}(aSavPos,1) = s*cosfi;
      koord{motePar}(aSavPos,2) = s*sin(fi);
   end 
   
   for a = fliplr(distances)
      b = a + dd{motePar};
		coslamd = 1/(2*a*d{motePar})*(a^2+d{motePar}^2-b^2);
      s = sqrt(a^2+d{motePar}^2/4-a*d{motePar}*coslamd);
      cosfi = 1/(s*d{motePar})*(s^2+d{motePar}^2/4-a^2);
      fi = acos(cosfi);
      aSavPos = aSavPos + 1;
      koord{motePar}(aSavPos,1) = s*cosfi;
      koord{motePar}(aSavPos,2) = -s*sin(fi);
   end 
   
   forgMx{motePar} = [cos(beta(motePar)), sin(beta(motePar)); -sin(beta(motePar)),cos(beta(motePar))];
   koord{motePar} = koord{motePar} * forgMx{motePar};
   koord{motePar} = koord{motePar} + repmat(P0{motePar},length(koord{motePar}),1);
      
end

hold on
for motePar = 1:3
	plot(koord{motePar}(:,1),koord{motePar}(:,2),'Color',szin(motePar))
end

axis(frameDisp)
pos = get(gcf,'Position');
sizeOfFr = [525 497];
set(gcf,'Position',[(pos(1:2)+pos(3:4)-sizeOfFr) sizeOfFr])


if (nargin>2)
	plot(varargin{1}(1),varargin{1}(2),'ok')   
end


%flegyenesek kirajzolsa a lehetsges rkezsi irnyok fel
%feHossz = 400;
%hold on
%for moteP = 1:moteSzam
%   plot([P0{moteP}(1),P0{moteP}(1)+cos(alfa(moteP)+beta(moteP))*feHossz],...
%       [P0{moteP}(2),P0{moteP}(2)+sin(alfa(moteP)+beta(moteP))*feHossz],...
%       szin(moteP+0))

%   hold on
%   plo=plot([P0{moteP}(1),P0{moteP}(1)+cos(-alfa(moteP)+beta(moteP))*feHossz],...
%       [P0{moteP}(2),P0{moteP}(2)+sin(-alfa(moteP)+beta(moteP))*feHossz],...
%       szin(moteP+0));
%    set(plo,'LineStyle','--');
%end

%hold off
grid